Index: /palm/trunk/SOURCE/shared_memory_io_mod.f90
===================================================================
--- /palm/trunk/SOURCE/shared_memory_io_mod.f90	(revision 4590)
+++ /palm/trunk/SOURCE/shared_memory_io_mod.f90	(revision 4591)
@@ -1,38 +1,42 @@
 !> @file shared_memory_io_mod.f90
-!------------------------------------------------------------------------------!
-! This file is part of PALM.
-!
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+!--------------------------------------------------------------------------------------------------!
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 1997-2020 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+!
 !
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! $Id$
 !
+! File re-formatted to follow the PALM coding standard
+!
+!
+! 
 ! Initial version (Klaus Ketelsen)
 !
-! 
-!
-! Description:
-! ------------
-!> handle MPI-IO or NetCDF-IO shared memory arrays.
-!> This module performs the organization of new communicators, adapted PE-grids
-!> and allocation of shared memory arrays. The IO itself is not done here.
-!------------------------------------------------------------------------------!
+!
+!
+! Description:
+! ------------
+!> Handle MPI-IO or NetCDF-IO shared memory arrays.
+!> This module performs the organization of new communicators, adapted PE-grids and allocation of
+!> shared memory arrays. The IO itself is not done here.
+!--------------------------------------------------------------------------------------------------!
  MODULE shared_memory_io_mod
 
@@ -48,21 +52,64 @@
 
     USE control_parameters,                                                                        &
-        ONLY:  maximum_grid_level, mg_switch_to_pe0_level, message_string
+        ONLY: maximum_grid_level,                                                                  &
+              message_string,                                                                      &
+              mg_switch_to_pe0_level
+
 
     USE indices,                                                                                   &
-        ONLY: nbgp, nnx, nny, nnz, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nzb, nzt
+        ONLY: nbgp,                                                                                &
+              nnx,                                                                                 &
+              nny,                                                                                 &
+              nnz,                                                                                 &
+              nx,                                                                                  &
+              nxl,                                                                                 &
+              nxlg,                                                                                &
+              nxr,                                                                                 &
+              nxrg,                                                                                &
+              ny,                                                                                  &
+              nyn,                                                                                 &
+              nyng,                                                                                &
+              nys,                                                                                 &
+              nysg,                                                                                &
+              nzb,                                                                                 &
+              nzt
 
     USE kinds,                                                                                     &
-        ONLY: wp, iwp
+        ONLY: iwp,                                                                                 &
+              wp
+
 
     USE transpose_indices,                                                                         &
-        ONLY:  nys_x, nyn_x, nys_z, nyn_z, nxl_z, nxr_z
+        ONLY: nxl_z,                                                                               &
+              nxr_z,                                                                               &
+              nyn_x,                                                                               &
+              nyn_z,                                                                               &
+              nys_x,                                                                               &
+              nys_z
+
+
 
     USE pegrid,                                                                                    &
-        ONLY: comm1dx, comm1dy, comm2d, ierr, myid, myidx, myidy, npex, npey, numprocs, pdims,     &
-              pleft, pnorth, pright, psouth, sendrecvcount_xy
+        ONLY: comm1dx,                                                                             &
+              comm1dy,                                                                             &
+              comm2d,                                                                              &
+              ierr,                                                                                &
+              myid,                                                                                &
+              myidx,                                                                               &
+              myidy,                                                                               &
+              npex,                                                                                &
+              npey,                                                                                &
+              numprocs,                                                                            &
+              pdims,                                                                               &
+              pleft,                                                                               &
+              pnorth,                                                                              &
+              pright,                                                                              &
+              psouth,                                                                              &
+              sendrecvcount_xy
+
 #if defined( __parallel )
     USE pegrid,                                                                                    &
-        ONLY: pcoord, reorder
+        ONLY: pcoord,                                                                              &
+              reorder
 #endif
 
@@ -75,14 +122,17 @@
 !
 !-- Type to store grid information
-    TYPE, PUBLIC ::  local_boundaries
-
-       INTEGER(iwp) ::  nxl
-       INTEGER(iwp) ::  nxr
-       INTEGER(iwp) ::  nys
-       INTEGER(iwp) ::  nyn
-       INTEGER(iwp) ::  nnx
-       INTEGER(iwp) ::  nny
-       INTEGER(iwp) ::  nx
-       INTEGER(iwp) ::  ny
+    TYPE, PUBLIC ::  local_boundaries  !<
+
+       INTEGER(iwp) ::  nnx  !<
+       INTEGER(iwp) ::  nny  !<
+       INTEGER(iwp) ::  nx   !<
+       INTEGER(iwp) ::  nxl  !<
+       INTEGER(iwp) ::  nxr  !<
+       INTEGER(iwp) ::  ny   !<
+       INTEGER(iwp) ::  nyn  !<
+       INTEGER(iwp) ::  nys  !<
+
+
+
 
     END TYPE local_boundaries
@@ -91,20 +141,20 @@
 !-- Class definition for shared memory instances.
 !-- For every use of shared memory IO, one instance of this class is created.
-    TYPE, PUBLIC ::  sm_class
-
-       INTEGER(iwp)         :: nr_io_pe_per_node = 2   !< typical configuration, 2 sockets per node
-       LOGICAL              :: no_shared_Memory_in_this_run
+    TYPE, PUBLIC ::  sm_class  !<
+
+       INTEGER(iwp) ::  nr_io_pe_per_node = 2         !< typical configuration, 2 sockets per node
+       LOGICAL      ::  no_shared_Memory_in_this_run  !<
 !
 !--    Variables for the shared memory communicator
-       INTEGER(iwp), PUBLIC ::  comm_shared    !< Communicator for processes with shared array
-       INTEGER(iwp), PUBLIC ::  sh_npes
-       INTEGER(iwp), PUBLIC ::  sh_rank
+       INTEGER(iwp), PUBLIC ::  comm_shared   !< Communicator for processes with shared array
+       INTEGER(iwp), PUBLIC ::  sh_npes       !<
+       INTEGER(iwp), PUBLIC ::  sh_rank       !<
 
        LOGICAL, PUBLIC ::  iam_io_pe = .TRUE.  !< This PE is an IO-PE
 !
 !--    Variables for the I/O virtual grid
-       INTEGER(iwp), PUBLIC ::  comm_io        !< Communicator for all IO processes
-       INTEGER(iwp), PUBLIC ::  io_npes
-       INTEGER(iwp), PUBLIC ::  io_rank
+       INTEGER(iwp), PUBLIC ::  comm_io  !< Communicator for all IO processes
+       INTEGER(iwp), PUBLIC ::  io_npes  !<
+       INTEGER(iwp), PUBLIC ::  io_rank  !<
 
        TYPE( local_boundaries ), PUBLIC ::  io_grid
@@ -112,31 +162,31 @@
 !
 !--    Variables for the node local communicator
-       INTEGER(iwp)         ::  comm_node      !< Communicator for all processes of current node
-       INTEGER(iwp)         ::  io_pe_global_rank
-       INTEGER(iwp)         ::  n_npes
-       INTEGER(iwp)         ::  n_rank
-
-       CONTAINS
-
-          PRIVATE
-
-          PROCEDURE, PASS(this), PUBLIC ::  is_sm_active
-          PROCEDURE, PASS(this), PUBLIC ::  sm_adjust_outer_boundary
-          PROCEDURE, PASS(this), PUBLIC ::  sm_free_shared
-          PROCEDURE, PASS(this), PUBLIC ::  sm_init_comm
-          PROCEDURE, PASS(this), PUBLIC ::  sm_node_barrier
-#if defined( __parallel )
-          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_1d
-          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_2d
-          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_2di
-          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_3d
+       INTEGER(iwp) ::  comm_node          !< Communicator for all processes of current node
+       INTEGER(iwp) ::  io_pe_global_rank  !<
+       INTEGER(iwp) ::  n_npes             !<
+       INTEGER(iwp) ::  n_rank             !<
+
+ CONTAINS
+
+       PRIVATE
+
+          PROCEDURE, PASS(this), PUBLIC ::  is_sm_active              !<
+          PROCEDURE, PASS(this), PUBLIC ::  sm_adjust_outer_boundary  !<
+          PROCEDURE, PASS(this), PUBLIC ::  sm_free_shared            !<
+          PROCEDURE, PASS(this), PUBLIC ::  sm_init_comm              !<
+          PROCEDURE, PASS(this), PUBLIC ::  sm_node_barrier           !<
+#if defined( __parallel )
+          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_1d   !<
+          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_2d   !<
+          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_2di  !<
+          PROCEDURE, PASS(this), PUBLIC ::  sm_allocate_shared_3d   !<
 
           GENERIC, PUBLIC ::  sm_allocate_shared =>  sm_allocate_shared_1d, sm_allocate_shared_2d, &
-                                                     sm_allocate_shared_2di, sm_allocate_shared_3d
+                                                  sm_allocate_shared_2di, sm_allocate_shared_3d  !<
 #endif
     END TYPE sm_class
 
 
-CONTAINS
+ CONTAINS
 
 
@@ -154,6 +204,6 @@
 
 #if defined( __parallel )
-    INTEGER             :: color
-    INTEGER             :: max_n_npes  !< Maximum number of PEs/node
+    INTEGER ::  color       !<
+    INTEGER ::  max_n_npes  !< Maximum number of PEs/node
 #endif
 
@@ -244,19 +294,19 @@
     IMPLICIT NONE
 
-    INTEGER(iwp), INTENT(OUT) :: color
-
-    INTEGER(iwp) ::  group_start
-    INTEGER(iwp) ::  n
-    INTEGER(iwp) ::  my_color
-    INTEGER(iwp) ::  pe
-    INTEGER(iwp) ::  sh_group_size
-
-    INTEGER(iwp), DIMENSION(4,0:this%n_npes-1) ::  local_dim_s
-    INTEGER(iwp), DIMENSION(4,0:this%n_npes-1) ::  local_dim_r
-
-    TYPE(local_boundaries), DIMENSION(32) ::  node_grid
-
-!
-!-- Nn shared memory I/O on one node jobs
+    INTEGER(iwp), INTENT(OUT) ::  color  !<
+
+    INTEGER(iwp) ::  group_start    !<
+    INTEGER(iwp) ::  my_color       !<
+    INTEGER(iwp) ::  n              !<
+    INTEGER(iwp) ::  pe             !<
+    INTEGER(iwp) ::  sh_group_size  !<
+
+    INTEGER(iwp), DIMENSION(4,0:this%n_npes-1) ::  local_dim_s   !<
+    INTEGER(iwp), DIMENSION(4,0:this%n_npes-1) ::  local_dim_r   !<
+
+    TYPE(local_boundaries), DIMENSION(32) ::  node_grid  !<
+
+!
+!-- No shared memory I/O on one node jobs
     IF ( numprocs < this%n_npes )  THEN
        this%no_shared_memory_in_this_run = .TRUE.
@@ -337,11 +387,11 @@
 !> Function to return if shared Memory IO is active.
 !--------------------------------------------------------------------------------------------------!
- FUNCTION is_sm_active( this) RESULT( ac )
-
-    IMPLICIT NONE
-
-    CLASS(sm_class), INTENT(inout) ::  this
-
-    LOGICAL ::  ac
+ FUNCTION is_sm_active( this ) RESULT( ac )
+
+    IMPLICIT NONE
+
+    CLASS(sm_class), INTENT(inout) ::  this  !<
+
+    LOGICAL ::  ac  !<
 
     ac = .NOT. this%no_shared_memory_in_this_run
@@ -360,21 +410,21 @@
     IMPLICIT NONE
 
-    CLASS(sm_class), INTENT(inout)  ::  this
-
-    INTEGER(iwp)                    ::  disp_unit
-    INTEGER(iwp), INTENT(IN)        ::  d1
-    INTEGER(iwp), INTENT(IN)        ::  d2
-    INTEGER(iwp), SAVE              ::  pe_from = 0
-    INTEGER(KIND=MPI_ADDRESS_KIND)  ::  rem_size
-    INTEGER(iwp), INTENT(OUT)       ::  win
-    INTEGER(KIND=MPI_ADDRESS_KIND)  ::  wsize
-
-    INTEGER, DIMENSION(1)           ::  buf_shape
-
-    REAL(wp), DIMENSION(:), POINTER ::  buf
-    REAL(wp), DIMENSION(:), POINTER ::  p1
-
-    TYPE(C_PTR), SAVE               ::  base_ptr
-    TYPE(C_PTR), SAVE               ::  rem_ptr
+    CLASS(sm_class), INTENT(inout) ::  this         !<
+                                                    !<
+    INTEGER(iwp)                   ::  disp_unit    !<
+    INTEGER(iwp), INTENT(IN)       ::  d1           !<
+    INTEGER(iwp), INTENT(IN)       ::  d2           !<
+    INTEGER(iwp), SAVE             ::  pe_from = 0  !<
+    INTEGER(KIND=MPI_ADDRESS_KIND) ::  rem_size     !<
+    INTEGER(iwp), INTENT(OUT)      ::  win          !<
+    INTEGER(KIND=MPI_ADDRESS_KIND) ::  wsize        !<
+
+    INTEGER, DIMENSION(1)           ::  buf_shape   !<
+
+    REAL(wp), DIMENSION(:), POINTER ::  buf         !<
+    REAL(wp), DIMENSION(:), POINTER ::  p1          !<
+
+    TYPE(C_PTR), SAVE               ::  base_ptr    !<
+    TYPE(C_PTR), SAVE               ::  rem_ptr     !<
 
 
@@ -415,23 +465,23 @@
     IMPLICIT NONE
 
-    CLASS(sm_class), INTENT(INOUT)    ::  this
-
-    INTEGER(iwp)                      ::  disp_unit
-    INTEGER(iwp), INTENT(IN)          ::  n_nxlg
-    INTEGER(iwp), INTENT(IN)          ::  n_nxrg
-    INTEGER(iwp), INTENT(IN)          ::  n_nyng
-    INTEGER(iwp), INTENT(IN)          ::  n_nysg
-    INTEGER(iwp), SAVE                ::  pe_from = 0
-    INTEGER(KIND=MPI_ADDRESS_KIND)    ::  rem_size
-    INTEGER(iwp), INTENT(OUT)         ::  win
-    INTEGER(KIND=MPI_ADDRESS_KIND)    ::  wsize
-
-    INTEGER(iwp), DIMENSION(2)        ::  buf_shape
-
-    REAL(wp), DIMENSION(:,:), POINTER ::  buf
-    REAL(wp), DIMENSION(:,:), POINTER ::  p2
-
-    TYPE(C_PTR),SAVE                  ::  base_ptr
-    TYPE(C_PTR),SAVE                  ::  rem_ptr
+    CLASS(sm_class), INTENT(INOUT)    ::  this         !<
+
+    INTEGER(iwp)                      ::  disp_unit    !<
+    INTEGER(iwp), INTENT(IN)          ::  n_nxlg       !<
+    INTEGER(iwp), INTENT(IN)          ::  n_nxrg       !<
+    INTEGER(iwp), INTENT(IN)          ::  n_nyng       !<
+    INTEGER(iwp), INTENT(IN)          ::  n_nysg       !<
+    INTEGER(iwp), SAVE                ::  pe_from = 0  !<
+    INTEGER(KIND=MPI_ADDRESS_KIND)    ::  rem_size     !<
+    INTEGER(iwp), INTENT(OUT)         ::  win          !<
+    INTEGER(KIND=MPI_ADDRESS_KIND)    ::  wsize        !<
+
+    INTEGER(iwp), DIMENSION(2)        ::  buf_shape    !<
+
+    REAL(wp), DIMENSION(:,:), POINTER ::  buf          !<
+    REAL(wp), DIMENSION(:,:), POINTER ::  p2           !<
+
+    TYPE(C_PTR),SAVE                  ::  base_ptr     !<
+    TYPE(C_PTR),SAVE                  ::  rem_ptr      !<
 
 
@@ -474,23 +524,23 @@
     IMPLICIT NONE
 
-    CLASS(sm_class), INTENT(inout)      :: this
-
-    INTEGER(iwp)                          ::  disp_unit
-    INTEGER(iwp), INTENT(IN)              ::  n_nxlg
-    INTEGER(iwp), INTENT(IN)              ::  n_nxrg
-    INTEGER(iwp), INTENT(IN)              ::  n_nyng
-    INTEGER(iwp), INTENT(IN)              ::  n_nysg
-    INTEGER(iwp), SAVE                    ::  pe_from = 0
-    INTEGER(kind=MPI_ADDRESS_KIND)        ::  rem_size
-    INTEGER(iwp), INTENT(OUT)             ::  win
-    INTEGER(kind=MPI_ADDRESS_KIND)        ::  wsize
-
-    INTEGER(iwp), DIMENSION(2)            ::  buf_shape
-
-    INTEGER(iwp), DIMENSION(:,:), POINTER ::  buf
-    INTEGER(iwp), DIMENSION(:,:), POINTER ::  p2i
-
-    TYPE(C_PTR),SAVE                      ::  base_ptr
-    TYPE(C_PTR),SAVE                      ::  rem_ptr
+    CLASS(sm_class), INTENT(inout)        ::  this         !<
+
+    INTEGER(iwp)                          ::  disp_unit    !<
+    INTEGER(iwp), INTENT(IN)              ::  n_nxlg       !<
+    INTEGER(iwp), INTENT(IN)              ::  n_nxrg       !<
+    INTEGER(iwp), INTENT(IN)              ::  n_nyng       !<
+    INTEGER(iwp), INTENT(IN)              ::  n_nysg       !<
+    INTEGER(iwp), SAVE                    ::  pe_from = 0  !<
+    INTEGER(kind=MPI_ADDRESS_KIND)        ::  rem_size     !<
+    INTEGER(iwp), INTENT(OUT)             ::  win          !<
+    INTEGER(kind=MPI_ADDRESS_KIND)        ::  wsize        !<
+
+    INTEGER(iwp), DIMENSION(2)            ::  buf_shape    !<
+
+    INTEGER(iwp), DIMENSION(:,:), POINTER ::  buf          !<
+    INTEGER(iwp), DIMENSION(:,:), POINTER ::  p2i          !<
+
+    TYPE(C_PTR),SAVE                      ::  base_ptr     !<
+    TYPE(C_PTR),SAVE                      ::  rem_ptr      !<
 
 
@@ -533,25 +583,25 @@
     IMPLICIT NONE
 
-    CLASS(sm_class), INTENT(inout)      ::  this
-
-    INTEGER                             ::  disp_unit
-    INTEGER, INTENT(IN)                 ::  d1e
-    INTEGER, INTENT(IN)                 ::  d1s
-    INTEGER, INTENT(IN)                 ::  d2e
-    INTEGER, INTENT(IN)                 ::  d2s
-    INTEGER, INTENT(IN)                 ::  d3e
-    INTEGER, INTENT(IN)                 ::  d3s
-    INTEGER, SAVE                       ::  pe_from = 0
-    INTEGER(KIND=MPI_ADDRESS_KIND)      ::  rem_size
-    INTEGER, INTENT(OUT)                ::  win
-    INTEGER(KIND=MPI_ADDRESS_KIND)      ::  wsize
-
-    INTEGER, DIMENSION(3)               ::  buf_shape
-
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  buf
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  p3
-
-    TYPE(C_PTR), SAVE                   ::  base_ptr
-    TYPE(C_PTR), SAVE                   ::  rem_ptr
+    CLASS(sm_class), INTENT(inout)      ::  this         !<
+
+    INTEGER                             ::  disp_unit    !<
+    INTEGER, INTENT(IN)                 ::  d1e          !<
+    INTEGER, INTENT(IN)                 ::  d1s          !<
+    INTEGER, INTENT(IN)                 ::  d2e          !<
+    INTEGER, INTENT(IN)                 ::  d2s          !<
+    INTEGER, INTENT(IN)                 ::  d3e          !<
+    INTEGER, INTENT(IN)                 ::  d3s          !<
+    INTEGER, SAVE                       ::  pe_from = 0  !<
+    INTEGER(KIND=MPI_ADDRESS_KIND)      ::  rem_size     !<
+    INTEGER, INTENT(OUT)                ::  win          !<
+    INTEGER(KIND=MPI_ADDRESS_KIND)      ::  wsize        !<
+
+    INTEGER, DIMENSION(3)               ::  buf_shape    !<
+
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  buf          !<
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  p3           !<
+
+    TYPE(C_PTR), SAVE                   ::  base_ptr     !<
+    TYPE(C_PTR), SAVE                   ::  rem_ptr      !<
 
 
@@ -596,5 +646,5 @@
     IMPLICIT NONE
 
-    CLASS(sm_class), INTENT(inout) ::  this
+    CLASS(sm_class), INTENT(inout) ::  this  !<
 
 
@@ -640,7 +690,7 @@
     IMPLICIT NONE
 
-    CLASS(sm_class), INTENT(inout) ::  this
-
-    INTEGER(iwp), INTENT(INOUT)    ::  win
+    CLASS(sm_class), INTENT(inout) ::  this  !<
+
+    INTEGER(iwp), INTENT(INOUT)    ::  win   !<
 
     IF ( this%no_shared_memory_in_this_run  .OR.  win == -1234567890 )  RETURN
@@ -662,5 +712,5 @@
     IMPLICIT NONE
 
-    CLASS(sm_class), INTENT(inout)     :: this
+    CLASS(sm_class), INTENT(inout) ::  this  !<
 
 
